import { GraphQLScalarType } from "graphql";
import { ValidatorOptions } from "class-validator";
import { ResolverFilterData } from "../interfaces";
export declare type TypeValue = ClassType | GraphQLScalarType | Function | object | symbol;
export declare type ReturnTypeFuncValue = TypeValue | [TypeValue];
export declare type TypeValueThunk = (type?: void) => TypeValue;
export declare type ClassTypeResolver = (of?: void) => ClassType;
export declare type ReturnTypeFunc = (returns?: void) => ReturnTypeFuncValue;
export declare type SubscriptionFilterFunc = (resolverFilterData: ResolverFilterData<any, any, any>) => boolean | Promise<boolean>;
export interface DecoratorTypeOptions {
    nullable?: boolean;
}
export interface TypeOptions extends DecoratorTypeOptions {
    array?: boolean;
}
export interface DescriptionOptions {
    description?: string;
}
export interface DepreciationOptions {
    deprecationReason?: string;
}
export interface ValidateOptions {
    validate?: boolean | ValidatorOptions;
}
export interface SchemaNameOptions {
    name?: string;
}
export declare type BasicOptions = DecoratorTypeOptions & DescriptionOptions;
export declare type AdvancedOptions = BasicOptions & DepreciationOptions & SchemaNameOptions;
export interface ClassType<T = any> {
    new (): T;
}
export interface EnumConfig {
    name: string;
    description?: string;
}
export declare type MethodAndPropDecorator = PropertyDecorator & MethodDecorator;
export interface ResolverClassOptions {
    isAbstract?: boolean;
}
//# sourceMappingURL=types.d.ts.map