"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const schema_generator_1 = require("../schema/schema-generator");
const loadResolversFromGlob_1 = require("../helpers/loadResolversFromGlob");
function buildSchema(options) {
    loadResolvers(options);
    return schema_generator_1.SchemaGenerator.generateFromMetadata(options);
}
exports.buildSchema = buildSchema;
function buildSchemaSync(options) {
    loadResolvers(options);
    return schema_generator_1.SchemaGenerator.generateFromMetadataSync(options);
}
exports.buildSchemaSync = buildSchemaSync;
function loadResolvers(options) {
    if (options.resolvers.length === 0) {
        throw new Error("Empty `resolvers` array property found in `buildSchema` options!");
    }
    options.resolvers.forEach(resolver => {
        if (typeof resolver === "string") {
            loadResolversFromGlob_1.loadResolversFromGlob(resolver);
        }
    });
}
